unit forexsrs;

{$mode objfpc}{$H+}

interface

uses
  Classes, Dialogs, SysUtils;

type
  TFXudrTwoStrings = record
     sDollars, sEuros:string;
     end;//defintion of type TFXudrTwoStrings

function InitForEx(rTmp:real):byte;
function sCalcUSD(sTmp:string):string;
function sVerForExSRs:string;
function sInterpErrCode(bWhatCode:byte;boShortVersion:boolean):string;
function bHighestUsedErrorCode:byte;
function sCalcDollarsAndEuros:TFXudrTwoStrings;

var
FXrRate:real;
boIniCalled:boolean=false;
udrTmp:TFXudrTwoStrings;

implementation

function bHighestUsedErrorCode:byte;
begin
  result:=1;
end;

function sInterpErrCode(bWhatCode:byte;boShortVersion:boolean):string;
//This could be done differently, but has been done like this to make
//   it easy to add new error code interpretations as the code in the
//   unit develops.
//The second parameter, if true, makes the SR yield short explanations
//   of the error. Longer explanations are the alternative.

//Boilerplate...
(*
:if boShortVersion then result:=''//no ; here
      else result:='';
  *)

begin
  case bWhatCode of
  0:if boShortVersion then result:='NoErr'//no ; here
      else result:='No error seen during subroutine call';
  1:if boShortVersion then result:='Exch rate=zero not allowed.'//no ; here
      else result:='Setting exchange rate to zero not possible because '+
         'divisions by zero would arise.';

  else //of case
    if boShortVersion then result:='Unrecognized err'//no ; here
      else result:='The coding of the sub-unit needs revision to handle an '+
         'as-yet un-provided for error code.';
  end;//of case
end;//sInterpErrCode

function sVerForExSRs:string;
begin
result:='16 May 16';
end;

function InitForEx(rTmp:real):byte;
//Establish the exchage rate which will be used
//   in calculating equivalents
//Set the flag which says that this subroutine
//   has been executed.
begin
  FXrRate:=rTmp;
  if rTmp=0 then result:=1 else result:=0;
  boIniCalled:=true;
end;//InitForEx

function sCalcUSD(sTmp:string):string;
var sTmp2:string;
    rTmp:real;
begin
  if boIniCalled=false then begin
     sTmp2:='sCalcUSD called before'+chr(13)+
        'IniForEx called.'+chr(13)+'Not allowed.';
     end//no ; here.

   else begin

    //Something about the following makes me "itch".
    //I suspect it could be done better! "But it works".
    //(The danger of an attempt to divide by zero has
    //   been taken care of elsewhere, at least.)

    sTmp2:='';
    try
        rTmp:=strtofloat(sTmp);
    except
        on exception do sTmp2:='Cannot convert';
    end;//try... except...

    if sTmp2='' then
      sTmp2:=floattostr(rTmp / FXrRate);

  end;//of "else" near top.

  result:=sTmp2;

end;//sCalcUSD

function sCalcDollarsAndEuros:TFXudrTwoStrings;
  var udrTmpL:TFXudrTwoStrings;
begin
  udrTmpL.sDollars:='100';
  udrTmpL.sEuros:='85';
  result:=udrTmpL;
end;

end.

